package cz.yanas.collections;

/**
 * Represents an immutable point in 3D space.
 *
 * @author yanas
 */
public final class Point implements Comparable<Point> {

    private final float x;
    private final float y;

    
    public Point(float x, float y) {
        this.x = x;
        this.y = y;
    }

    public float getX() {
        return x;
    }

    /**
     * Blah, blah.
     * 
     * @return y
     */
    public float getY() {
        return y;
    }

    @Override
    public boolean equals(Object object) {
        if (object == this) {
            return true;
        }

        if (!(object instanceof Point)) {
            return false;
        }

        Point point = (Point) object;

        return (point.getX() == x && point.getY() == y);
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 23 * hash + Float.floatToIntBits(this.x);
        hash = 23 * hash + Float.floatToIntBits(this.y);

        return hash;
    }

    @Override
    public String toString() {
        return ("[" + x + ", " + y + "]");
    }

    public int compareTo(Point point) {
        if (point.equals(this)) {
            return 0;
        }

        if (x < point.getX()
                || (x == point.getX() && y < point.getY())) {
            return -1;
        }

        return 1;
    }
}
